var conn = require('./smart.js');
var nodeid = '';

conn.init(function(ready) {
	console.log('conexion establecida con Concepto DSL');
});

conn.on({
	'who_are_you'	:  function(data) {
		conn.send.login('nexo');
		console.log('conn:who_are_you: enviado login');
	},
	'user_information' :  function(data) {
		console.log('*** DATOS DE QUE CONCEPTO RECIBIDOS! ****',data);
		//conn.send.login('nexo');
	},
	'welcome'  :  function(data) {
		console.log('*** CONCEPTO NOS HA SALUDADO CON SU MAPA:', data);
	},
	'goodbye'  :  function(data) {
		console.log('*** Concepto nos dijo adios... :) ***');
	},
	'transaction' : function(data) {
		if (conn.getLastID()!=data['$'].id) {
			// solo ejecutamos transaccion si no fuimos nosotros mismos.
			conn.parseXml(data['$'].do_action, function(tag, js) {
				//var nodeid = '';
				if ('$' in js && 'node' in js['$']) nodeid = js['$'].node;
				console.log('*** ACCION '+tag+' SOLICITADA SOBRE NODE ID: '+nodeid+':',js);
			});
		}
		//console.log('dump de transaction:',data);
	},
	'*'	: function(data, comando) {
		console.log('*** EVENTO GENERICO DETECTADO (cmd:'+comando+'): ***', data);
	}
});

// probamos enviar en 10 segundos comando para definir una nube en un nodo x:
setTimeout(function(){
	if (nodeid!='') {
		console.log('EJECUTANDO NUBE.... SOBRE ULTIMO NODO ID:'+nodeid);
		conn.send.transaction(
			{
				'add_cloud_xml_action'	: {
					'@' : {
						'node' 		: nodeid,
						'enabled'	: true
					}
				}
			},
			{
				'add_cloud_xml_action'	: {
					'@' : {
						'node' 		: nodeid,
						'enabled'	: false
					}
				}
			}
		);
	} else {
		console.log('OMITIMOS EJECUTAR NUBE PORQUE NO HAY UN ULTIMO ID DEFINIDO O MODIFICADO');
	}
},15000);