var smart = require('./smart');
var apple = require('../apple/apple');

smart.init(function(ready) {
	apple.say('Conectados con Concepto D ese ele Laiv.');	
	console.log('conexion establecida con Concepto DSL Live');
});

var logfull = function(msg, data) {
	console.log(msg, JSON.stringify(data));
};

smart.on({
	'who_are_you'	:  function(data) {
		smart.send.login('nexo');
		console.log('conn:who_are_you: enviado login');
	},
	'user_information' :  function(data) {
		console.log('smart:ping ..');
	},
	'welcome'  :  function(data) {
		console.log('smart:welcome:mapa_recibido');
	},
	'goodbye'  :  function(data) {
		apple.say('smart nos ha despedido. Adios.');
		console.log('*** smart nos dijo adios... :) ***');
	},
	'transaction' : function(data) {
		if (smart.getLastID()!=data['$'].id) {
			// solo ejecutamos transaccion si no fuimos nosotros mismos.
			smart.parseXml(data['$'].do_action, function(tag, js) {
				//var nodeid = '';
				if ('$' in js && 'node' in js['$']) nodeid = js['$'].node;
				logfull('*** ACCION '+tag+' SOLICITADA SOBRE NODE ID: '+nodeid+':',js);
				apple.say('Accion '+(tag.split('_').join(' '))+' solicitada en nodo.');
			});
		}
		//console.log('dump de transaction:',data);
	},
	'*'	: function(data, comando) {
		console.log('*** EVENTO GENERICO DETECTADO (cmd:'+comando+'): ***', data);
	}
});

/*
setTimeout(function() {
	smart.getMap(function(enjs) {
		logfull('test5:mapa que tengo en JS:\n',enjs);
	});
}, 5000);*/